'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /* flow */

var _keys = require('lodash/fp/keys');

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (state, onChange) {
    return {
        get: function get(key) {
            if (!state) {
                return null;
            }

            var workflow = state.workflow,
                name = state.name,
                meta = state.meta;


            var nextSteps = null;
            var task = null;

            if (workflow) {
                task = workflow.task;
                nextSteps = (0, _keys2.default)(workflow.next);
            }

            var output = {
                name: name,
                meta: meta,
                nextSteps: nextSteps,
                task: task
            };

            return key ? output[key] : output;
        },
        start: function start(workflow, name, initialMeta) {
            onChange({
                workflow: workflow,
                name: name,
                meta: initialMeta
            });
        },
        next: function next(nextStep) {
            var metaUpdater = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function (ii) {
                return ii;
            };

            var _ref = state || {},
                workflow = _ref.workflow;

            if (!workflow || !workflow.next || !workflow.next.hasOwnProperty(nextStep)) {
                onChange({});
                return;
            }

            onChange(_extends({}, state, {
                workflow: workflow.next[nextStep],
                meta: metaUpdater(state.meta)
            }));
        },
        end: function end() {
            onChange({});
        }
    };
};