'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = EntityEditorState;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Compose = require('stampy/lib/util/Compose');

var _Compose2 = _interopRequireDefault(_Compose);

var _reactRedux = require('react-redux');

var _EntityEditorState = require('../EntityEditorState');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// this is required to be able to cope with multiple calls to entityEditorStateChange without a re-render
// makes entityEditorStateChange behave like setState normally does

function ShallowMergeChanges(Component) {
    return function (_React$Component) {
        _inherits(ShallowMergeChanges, _React$Component);

        function ShallowMergeChanges(props) {
            _classCallCheck(this, ShallowMergeChanges);

            var _this = _possibleConstructorReturn(this, (ShallowMergeChanges.__proto__ || Object.getPrototypeOf(ShallowMergeChanges)).call(this, props));

            _this.upToDateValue = props.entityEditorState;
            return _this;
        }

        _createClass(ShallowMergeChanges, [{
            key: 'componentWillReceiveProps',
            value: function componentWillReceiveProps(_ref) {
                var entityEditorState = _ref.entityEditorState;

                this.upToDateValue = entityEditorState;
            }
        }, {
            key: 'render',
            value: function render() {
                var _this2 = this;

                return _react2.default.createElement(Component, _extends({}, this.props, {
                    entityEditorStateChange: function entityEditorStateChange(payload) {
                        _this2.props.entityEditorStateChange(_extends({}, _this2.upToDateValue, payload));
                    }
                }));
            }
        }]);

        return ShallowMergeChanges;
    }(_react2.default.Component);
}

function EntityEditorState(config) {
    var editorKey = config.get('id');
    return (0, _Compose2.default)((0, _reactRedux.connect)(function (state) {
        return {
            entityEditorState: state.entityEditor[editorKey] || (0, _EntityEditorState.initialState)(config)
        };
    }), function (Component) {
        return function (props) {
            return _react2.default.createElement(Component, _extends({}, props, {
                entityEditorStateChange: function entityEditorStateChange(state) {
                    return props.dispatch({
                        type: "ENTITY_EDITOR_SET",
                        payload: {
                            editorKey: editorKey,
                            state: state
                        }
                    });
                }
            }));
        };
    }, ShallowMergeChanges);
}